## wcd 6.0.5

=== Makefile ===
# Copyright (C) 2009-2011 Erwin Waterlander
# Copyright (C) 2009 Jari Aalto
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# Visit <https://www.gnu.org/copyleft/gpl.html>


# This makefile is intended only for Unix/Linux.
# See also documentation in directory `doc'.

ifneq (,)
This makefile requires GNU Make.
endif

OBJDIR  = src

all:
	$(MAKE) -C $(OBJDIR)

clean:
	$(MAKE) -C $(OBJDIR) clean

distclean:
	$(MAKE) -C $(OBJDIR) distclean

maintainer-clean:
	$(MAKE) -C $(OBJDIR) maintainer-clean

realclean: maintainer-clean

install:
	$(MAKE) -C $(OBJDIR) install

uninstall:
	$(MAKE) -C $(OBJDIR) uninstall

.PHONY: clean distclean realclean install

# End of file

=== dos32/Makefile ===
include ../src/version.mk

PREFIX = c:/dos32
prefix = $(PREFIX)
MKDIR  = mkdir

CFLAGS = -O2 -Wall -Wextra -Wconversion
CURSES = pdcurses
ENABLE_NLS =
DEFS   =

ifdef CONIO
CURSES=
DEFS   += -DWCD_USECONIO
endif

ifdef CURSES
LIB_CURSES = -l${CURSES}
DEFS   += -DWCD_USECURSES
endif

PROGRAM = wcd.exe
VERSIONSUFFIX = pm
ZIPFILE = wcd${VERSION_SHORT}${VERSIONSUFFIX}.zip
ZIPOBJ_EXTRA = bin/cwsdpmi.exe
docsubdir = wcd-${VERSION_SHORT}

ifdef ENABLE_NLS
LIBS_EXTRA = -lintl -liconv
ZIPFILE = wcd${VERSION_SHORT}pm-nls.zip
endif

# The install and dist targets can be run in MSYS. The OS variable must be
# forced to msdos, otherwise extra targets will get build in MSYS.

# On DOS we need to set SHELL to sh.exe or bash.exe, otherwise targets may fail
# (targets install and dist fail certainly). SHELL can't be overridden in this
# make level. It sticks to command.com (at least with DJGPP 2.03 make 3.79.1).
# SHELL has to be set in a parent process, so we pass it to the sub make instances.
D2U_MAKESHELL=$(shell which sh)

all :
	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} ENABLE_NLS=${ENABLE_NLS} docsubdir=$(docsubdir) OS=msdos SHELL=$(D2U_MAKESHELL)

install :
	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS} docsubdir=$(docsubdir) OS=msdos SHELL=$(D2U_MAKESHELL)

uninstall :
	${MAKE} -C ../src uninstall PROGRAM=${PROGRAM} prefix=${prefix} ENABLE_NLS=${ENABLE_NLS} docsubdir=$(docsubdir) OS=msdos SHELL=$(D2U_MAKESHELL)


dist :
	${MAKE} -C ../src dist-zip ZIPOBJ_EXTRA="${ZIPOBJ_EXTRA}" PROGRAM=${PROGRAM} prefix=${prefix} ZIPFILE=${ZIPFILE} ENABLE_NLS=${ENABLE_NLS} docsubdir=$(docsubdir) OS=msdos SHELL=$(D2U_MAKESHELL)

strip:
	${MAKE} -C ../src strip PROGRAM=${PROGRAM} SHELL=$(D2U_MAKESHELL)

mostlyclean :
	${MAKE} -C ../src mostlyclean SHELL=$(D2U_MAKESHELL)

clean :
	${MAKE} -C ../src clean SHELL=$(D2U_MAKESHELL)

=== os2bash/Makefile ===

PREFIX = c:/usr
prefix = $(PREFIX)
exec_prefix = $(prefix)
MKDIR  = mkdir
LDFLAGS_EXTRA = -Zhigh-mem -Zomf -Zargs-resp

CFLAGS = -O2 -Wall

# PDcurses
#CURSES = pdcurses
# Ncurses
CURSES = ncurses
ENABLE_NLS =
DEFS   = -DWCD_OS2BASH

ifeq ($(CURSES),pdcurses)
LIB_CURSES = pdcurses.a
DEFS   += -DWCD_USECURSES
endif

ifeq ($(CURSES),ncurses)
LIB_CURSES = -lncurses -ltinfo
DEFS   += -DWCD_USECURSES
endif

LIBS_EXTRA =
ifdef ENABLE_NLS
LIBS_EXTRA += -lintl
endif

bindir    = ${exec_prefix}/bin
PROGRAM = wcdos2bash.exe
VERSIONSUFFIX = -os2bash

all :
	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES="${LIB_CURSES}" DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" LDFLAGS_EXTRA="${LDFLAGS_EXTRA}" prefix=${prefix} ENABLE_NLS=${ENABLE_NLS} OS=os/2

install :
	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES="${LIB_CURSES}" DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" LDFLAGS_EXTRA="${LDFLAGS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS} OS=os/2

uninstall :
	${MAKE} -C ../src uninstall PROGRAM=${PROGRAM} prefix=${prefix} ENABLE_NLS=${ENABLE_NLS}


dist :
	${MAKE} -C ../src dist-zip ZIPOBJ_EXTRA="${ZIPOBJ_EXTRA}" PROGRAM=${PROGRAM} prefix=${prefix} VERSIONSUFFIX=${VERSIONSUFFIX} ENABLE_NLS=${ENABLE_NLS}

strip:
	${MAKE} -C ../src strip PROGRAM=${PROGRAM}

mostlyclean :
	${MAKE} -C ../src mostlyclean

clean :
	${MAKE} -C ../src clean

=== src/Makefile ===
#   Copyright information
#
#       Copyright (C) 2009-2022 Erwin Waterlander
#       Copyright (C) 2009 Jari Aalto
#
#   License
#
#       This program is free software; you can redistribute it and/or
#       modify it under the terms of the GNU General Public License as
#       published by the Free Software Foundation; either version 2 of the
#       License, or (at your option) any later version
#
#       This program is distributed in the hope that it will be useful, but
#       WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#       General Public License for more details at
#       Visit <https://www.gnu.org/copyleft/gpl.html>.
#
#   Description
#
#       This is a GNU Makefile that uses GNU compilers, linkers and cpp. The
#       platform specific issues are determined by the various OS teets that
#       rely on the uname(1) command and directory locations.
#
#   Developer notes
#
#       In order to clean generated POD files and manuals:
#
#           make maintainer-clean
#
#       Set additional flags for the build with variables CFLAGS_USER,
#       DEFS_USER and LDFLAGS_USER.

ifneq (,)
This makefile requires GNU Make.
endif

include version.mk

.PHONY: status uninstall install install-man install-doc install-pdf dist dist-zip dist-tgz
.PHONY: doc man txt html ps pdf mofiles tags merge


.PRECIOUS: %.1 %.pod

CC              ?= gcc
STATIC          =
STRIP           = strip

ENABLE_NLS = 1

PACKAGE         = wcd
EXT             = .exe
PROGRAM         = $(PACKAGE)$(EXT)
BIN             = $(PROGRAM)

PREFIX          = /usr
prefix          = $(PREFIX)
exec_prefix     = $(prefix)
bindir          = $(exec_prefix)/bin
datarootdir     = $(prefix)/share
datadir         = $(datarootdir)

docsubdir       = $(PACKAGE)-$(VERSION)
docdir          = $(datarootdir)/doc/$(docsubdir)
localedir       = $(datarootdir)/locale
sysconfdir      = /etc

# 1 = regular, 5 = conf, 6 = games, 8 = daemons
mandir          = $(datarootdir)/man
man1dir         = $(mandir)/man1


# On some systems (e.g. FreeBSD 4.10) GNU install is installed as `ginstall'.
INSTALL         = install
# On some systems (e.g. GNU Win32) GNU mkdir is installed as `gmkdir'.
MKDIR           = mkdir

INSTALL_PROGRAM = $(INSTALL) -m 755
INSTALL_DATA    = $(INSTALL) -m 644
INSTALL_SUID    = $(INSTALL) -m 4755

INSTALL_OBJS_BIN   = $(BIN)
HTMLEXT = htm

# English manual
MANFILES_EN  = man/man1/wcd.1
TXTFILES_EN  = man/man1/wcd.txt
HTMLFILES_EN  = man/man1/wcd.$(HTMLEXT)
PSFILES_EN  = man/man1/wcd.ps
PDFFILES_EN  = man/man1/wcd.pdf

# Documents for end users, not for developers:
INSTALL_OBJS_DOC   = \
  ../doc/faq.txt \
  ../doc/whatsnew.txt \
  ../doc/README.txt \
  ../doc/problems.txt \
  ../doc/todo.txt \
  ../doc/INSTALL.txt \
  ../doc/UNIX.txt \
  ../doc/copying.txt

ifdef ENABLE_NLS
POT             = po/$(PACKAGE).pot
POFILES         = $(wildcard po/*.po)
MOFILES         = $(patsubst %.po,%.mo,$(POFILES))
NLSSUFFIX       = -nls
endif

# International manuals
ifdef ENABLE_NLS
MANPOTFILE      = po-man/wcd-man.pot
MANPOFILES      = $(wildcard po-man/*.po)
MANPODFILES     = $(patsubst po-man/%.po,man/%/man1/wcd.pod,$(MANPOFILES))
endif
MANFILES        = $(patsubst %.pod,%.1,$(MANPODFILES))
TXTFILES        = $(patsubst %.pod,%.txt,$(MANPODFILES))
HTMLFILES       = $(patsubst %.pod,%.$(HTMLEXT),$(MANPODFILES))
PSFILES         = $(patsubst %.pod,%.ps,$(MANPODFILES))
PDFFILES        = $(patsubst %.pod,%.pdf,$(MANPODFILES))

CPP             = cpp
CFLAGS_VERSION  = -DVERSION=\"$(VERSION)\" -DVERSION_DATE=\"$(VERSION_DATE)\"
DEF_UNIX        = -DUNIX
EXTRA_DEFS      =

VERSIONSUFFIX   = -bin

# Large File Support (LFS)
LFS             = 1
# DEBUG=1 adds the -g option to CFLAGS, for adding debug symbols.
DEBUG = 0
# DEBUGMSG=1 adds -DDEBUG=1 to CFLAGS, for extra verbose messages.
DEBUGMSG = 0

wcd_os := $(shell uname)

# Enble Unicode
UCS = 1
ifdef WCD_UTF8
        # WCD_UTF8 was used in older versions.
        UCS=1
endif
ifdef UNINORM
        UCS = 1
endif


ZIPOBJ          = bin/$(BIN) \
                  share/man/man1/$(PACKAGE).1 \
                  share/doc/$(docsubdir)/*.* \
                  $(ZIPOBJ_EXTRA)

INSTALL_TARGETS = install-bin install-man install-doc

ifdef ENABLE_NLS
        INSTALL_TARGETS += install-mo
        ZIPOBJ += share/locale/*/LC_MESSAGES/$(PACKAGE).mo
        ZIPOBJ += share/man/*/man1/$(PACKAGE).1
        ZIPOBJ += share/doc/$(docsubdir)/*/*
endif

ifdef ENABLE_NLS
        NLSDEFS    = -DENABLE_NLS -DLOCALEDIR=\"$(localedir)\" -DPACKAGE=\"$(PACKAGE)\"
endif

# ......................................................... OS flags ...

OS =

ifndef OS
ifeq ($(findstring CYGWIN,$(wcd_os)),CYGWIN)
        OS = cygwin
endif
endif

ifndef OS
ifeq ($(findstring MSYS,$(wcd_os)),MSYS)
        OS = msys
# MSYS 1 does not support locales and no Unicode.
ifeq ($(shell ./chk_loc.sh en_US.utf8),no)
        MSYS_VERSION=1
else
        MSYS_VERSION=2
endif
endif
endif

ifndef OS
ifeq ($(findstring MINGW,$(wcd_os)),MINGW)
        OS = mingw
endif
endif

ifndef OS
ifneq ($(DJGPP),)
        OS = msdos
endif
endif

ifndef OS
ifneq (, $(wildcard /opt/csw))
        OS = sun
endif
endif

ifndef OS
        OS=$(shell echo $(wcd_os) | tr '[A-Z]' '[a-z]')
endif


ifeq (cygwin,$(OS))
ifdef ENABLE_NLS
        LIBS_EXTRA    = -lintl -liconv -lmpr
else
        LIBS_EXTRA    = -lmpr
endif
        UNINORM = 1  
        LDFLAGS_EXTRA = -Wl,--enable-auto-import
        INSTALL_TARGETS += install-profile
        docsubdir       = $(PACKAGE)
        MACHINE := $(subst -pc-cygwin,,$(shell gcc -dumpmachine))
        VERSIONSUFFIX   = -cygwin-$(MACHINE)
endif

ifeq (os/2,$(OS))
        prefix = c:/usr
        PROGRAM = wcdos2.exe
        DEF_UNIX =
        UCS =
        UNINORM =
        LDFLAGS_EXTRA = -Zhigh-mem -Zomf -Zargs-resp
        ZIPOBJ_EXTRA=bin/wcd.cmd
        VERSIONSUFFIX = -os2
        LIBS_EXTRA =
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl
endif
endif

ifeq (mingw,$(OS))
        CC = gcc
        DEF_UNIX =
        LIBS_EXTRA = -lkernel32 -luser32 -lmpr
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl -liconv
endif
endif

ifeq (msdos,$(OS))
        CC = gcc
        DEF_UNIX =
        UCS =
        UNINORM =
endif

ifeq (msys,$(OS))
        CC = gcc
        CFLAGS_OS = -DWCD_MSYS
        PROGRAM = wcdmsys.exe
        LIBS_EXTRA  = -lkernel32 -luser32 -lmpr
        MACHINE := $(subst -pc-msys,,$(shell gcc -dumpmachine))
ifeq ($(MSYS_VERSION),1)
        UCS =
        UNINORM =
        VERSIONSUFFIX = -msys1-$(MACHINE)-$(CURSES)
else
        UCS = 1
        UNINORM = 1
        VERSIONSUFFIX = -msys2-$(MACHINE)
endif
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl -liconv
endif
endif

ifeq (freebsd,$(OS))
        # Running under FreeBSD
ifdef ENABLE_NLS
        CFLAGS_OS     = -I/usr/local/include
        LDFLAGS_EXTRA = -L/usr/local/lib
        LIBS_EXTRA    = -lintl
endif
endif

ifeq (darwin, $(OS))
ifdef ENABLE_NLS
        CFLAGS_OS     = -I/usr/local/include
        LDFLAGS_EXTRA = -L/usr/local/lib
        LIBS_EXTRA    = -lintl
endif
endif


ifeq (sun,$(OS))
        # Running under SunOS/Solaris
        LIBS_EXTRA = -lintl
endif

ifeq (hp-ux,$(OS))
        # Running under HP-UX
        EXTRA_DEFS += -Dhpux -D_HPUX_SOURCE -D_XOPEN_SOURCE_EXTENDED

        # These flags were for native HP compiler
        # CFLAGS_OS = -O -Aa
endif

# .......................................................... unicode ...

ifdef UCS
        CFLAGS_UCS = -std=gnu99
        WDEFS      = -DWCD_UNICODE
endif
ifdef UNINORM
        CFLAGS_UCS = -std=gnu99
        WDEFS      = -DWCD_UNICODE -DWCD_UNINORM
        LIB_UNISTRING  = -lunistring
endif

ifdef UCS
UCSSUFFIX = -ucs
EXTRA_OBJ += matchw.o
endif

# ........................................................... curses ...

# possible values: ncurses, curses, pdcurses, pdcursesw or <empty>

ifdef UCS
        CURSES = ncursesw
else
        CURSES = ncurses
endif


# The default console for msys1 is the cmd.exe console.  rxvt and mintty are
# available for msys1, but I guess most people use cmd, console, or conemu for
# msys1.  Therefore we use pdcurses for msys1.  msys2's default console is
# mintty. For msys2 we use ncurses.
ifeq (msys,$(OS))
ifeq ($(MSYS_VERSION),1)
        CURSES = pdcurses
endif
endif

# The native Windows versions use PDCurses, because there are problems
# with the ncurses mingw port.
# All native Windows versions (with and without Unicode support) use wide
# (Unicode) curses functions.
ifeq (mingw,$(OS))
        CURSES = pdcursesw
endif

ifdef CURSES
ifdef UCS
EXTRA_OBJ += wcwidth.o
endif
endif

ifneq (,$(CURSES))
        DEFS_CURSES = -DWCD_USECURSES
        LIB_CURSES  = -l$(CURSES)
ifeq (os/2,$(OS))
        LIB_CURSES  += -ltinfo
endif
endif


INCPREFIX=/usr
ifeq ($(findstring MINGW,$(wcd_os)),MINGW)
ifeq ($(shell gcc -dumpmachine),i686-w64-mingw32)
INCPREFIX=/mingw32
CFLAGS_COMPILER = -DWCD_MINGW32_W64=1
else
ifeq ($(shell gcc -dumpmachine),x86_64-w64-mingw32)
INCPREFIX=/mingw64
else
INCPREFIX=/mingw
endif
endif
endif

# Each ncurses variant has its own include directory
# ncurses (normal)/ncursesw (wide char)/ncursest (threads)
ifeq ($(findstring ncurses,$(CURSES)),ncurses)
ifneq ($(wildcard $(INCPREFIX)/include/$(CURSES)/curses.h),)
        INCFLAGS = -I$(INCPREFIX)/include/$(CURSES) -I$(INCPREFIX)/include
endif
ifeq ($(NCURSES_DEBUG), 1)
        LIB_CURSES  = -l$(CURSES)_g
endif
else
        INCFLAGS = -I$(INCPREFIX)/include
endif

ifeq ($(CURSES),ncursesw)
        EXTRA_DEFS += -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED
endif

ifeq ($(CURSES),pdcursesw)
        EXTRA_DEFS += -DPDC_STATIC_BUILD -DPDC_WIDE
endif

# Local installation prefix of ncurses.
#LOCAL_NCURSES  = $(HOME)
#
#ifneq (, $(wildcard $(LOCAL_NCURSES)/include/ncurses.h))
#       NCFLAG = -I$(LOCAL_NCURSES)/include
#       NLFLAG = -L$(LOCAL_NCURSES)/lib
#endif

# ............................................................ flags ...

# Statically linking of a specific library can be done by linking
# to a lib*.a library file instead a lib*.s* library file.
# To link ncurses statically (if your system links by default
# dynamically) comment the LDFLAGS line and add the 'libncurses.a' file
# (often found as /usr/lib/libncurses.a) to the OBJS1 list.

CFLAGS_USER     =
ifeq ($(DEBUG), 1)
CFLAGS_OPT = -O0
else
CFLAGS_OPT = -O2
endif

CFLAGS  ?=
CFLAGS  += $(CFLAGS_OPT)
ifeq ($(DEBUG), 1)
        CFLAGS += -g
endif
CFLAGS  += -Wall -Wextra -Wno-unused-parameter -Wconversion $(RPM_OPT_FLAGS) $(CPPFLAGS) $(CFLAGS_USER)


EXTRA_CFLAGS    = -Ic3po \
                  $(CFLAGS_VERSION) \
                  $(CFLAGS_OS) \
                  $(CFLAGS_UCS) \
                  $(CFLAGS_COMPILER) \
                  $(WDEFS) \
                  $(NLSDEFS) \
                  $(NCFLAG) \
                  $(INCFLAGS) \
                  -DDEBUG=$(DEBUGMSG)

ifdef LFS
        EXTRA_CFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
endif

ifdef ASCII_TREE
        EXTRA_CFLAGS += -DASCII_TREE
endif

ifdef STATIC
        LDFLAG_STATIC = -static
endif

LDFLAGS_USER   =
LDFLAGS ?=
LDFLAGS += $(RPM_LD_FLAGS) \
           $(LDFLAGS_EXTRA) \
           $(NLFLAG) \
           $(LDFLAG_STATIC) \
           $(LDFLAGS_USER)

LIBS = $(LIB_CURSES) \
       $(LIB_UNISTRING) \
       $(LIBS_EXTRA)

DEFS_USER   =
DEFS            = $(DEF_UNIX) $(DEFS_CURSES) $(EXTRA_DEFS) $(DEFS_USER)

# .......................................................... targets ...

OBJS1 = \
        wcd.o \
        match.o \
        stack.o \
        nameset.o \
        intset.o \
        Error.o \
        Text.o \
        WcdStack.o \
        dirnode.o \
        display.o \
        wfixpath.o \
        wcddir.o \
        matchl.o \
        querycp.o \
        finddirs.o \
        $(EXTRA_OBJ)

ifneq (,$(CURSES))
OBJS1 += colors.o \
        graphics.o
endif

all: $(BIN) doc mofiles man

status:
	@echo "-- $(PACKAGE) Makefile settings begin --"
	@echo "OS            = $(OS)"

=== win32/Makefile ===

PREFIX = c:/usr/local
prefix = $(PREFIX)
exec_prefix = $(prefix)
MKDIR  = mkdir
LIBS_EXTRA = -lkernel32 -luser32 -lmpr

CFLAGS = -O2 -Wall -Wextra -Wconversion -Wno-unused-parameter
CURSES = pdcursesw
ENABLE_NLS =
DEFS   =

ifdef CURSES
LIB_CURSES = -l${CURSES}
DEFS   += -DWCD_USECURSES -DPDC_STATIC_BUILD
DEFS   += -DPDC_WIDE
EXTRA_OBJ += wcwidth.o
endif


ifdef ENABLE_NLS
LIBS_EXTRA += -lintl -liconv
endif

UCS=1

ifdef UNINORM
UCS=1
endif

ifdef UCS
EXTRA_OBJ += matchw.o
endif

bindir    = ${exec_prefix}/bin
PROGRAM = wcdwin32.exe
VERSIONSUFFIX = -win32
ZIPOBJ_EXTRA = bin/wcd.bat bin/wcd_win95.bat
ifdef ENABLE_NLS
# Using MinGW gettext,iconv
ZIPOBJ_EXTRA += bin/libintl-8.dll bin/libiconv-2.dll
# libgcc_s_dw2-1 and libwinpthread-1 are needed when built with MSYS2 
ZIPOBJ_EXTRA += bin/libgcc_s_dw2-1.dll bin/libwinpthread-1.dll
endif

ifdef UNINORM
ifndef ENABLE_NLS
ZIPOBJ_EXTRA += bin/libgcc_s_dw2-1.dll bin/libwinpthread-1.dll
# libunistring needs libiconv
ZIPOBJ_EXTRA += bin/libiconv-2.dll
endif
ZIPOBJ_EXTRA += bin/libunistring-2.dll
endif

ifeq ($(findstring ncurses,$(CURSES)),ncurses)
ifneq ($(findstring libwinpthread,$(ZIPOBJ_EXTRA)),libwinpthread)
ZIPOBJ_EXTRA += bin/libwinpthread-1.dll
endif
endif


all :
	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} EXTRA_OBJ="${EXTRA_OBJ}" ENABLE_NLS=${ENABLE_NLS}

install :
	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} EXTRA_OBJ="${EXTRA_OBJ}" INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS}
	install -m 755 wcd.bat $(DESTDIR)${bindir}/wcd.bat
	install -m 755 wcd_win95.bat $(DESTDIR)${bindir}/wcd_win95.bat

uninstall :
	${MAKE} -C ../src uninstall PROGRAM=${PROGRAM} prefix=${prefix} ENABLE_NLS=${ENABLE_NLS}
	-rm -f $(DESTDIR)${bindir}/wcd.bat
	-rm -f $(DESTDIR)${bindir}/wcd_win95.bat


dist :
	${MAKE} -C ../src dist-zip ZIPOBJ_EXTRA="${ZIPOBJ_EXTRA}" PROGRAM=${PROGRAM} prefix=${prefix} VERSIONSUFFIX=${VERSIONSUFFIX} ENABLE_NLS=${ENABLE_NLS}

strip:
	${MAKE} -C ../src strip PROGRAM=${PROGRAM}

mostlyclean :
	${MAKE} -C ../src mostlyclean

clean :
	${MAKE} -C ../src clean

=== win32psh/Makefile ===

PREFIX = c:/usr/local
prefix = $(PREFIX)
exec_prefix = $(prefix)
MKDIR  = mkdir
LIBS_EXTRA = -lkernel32 -luser32 -lmpr

CFLAGS = -O2 -Wall -Wextra -Wconversion -Wno-unused-parameter
CURSES = pdcursesw
ENABLE_NLS =
DEFS   = -DWCD_WINPWRSH

ifdef CURSES
LIB_CURSES = -l${CURSES}
DEFS   += -DWCD_USECURSES -DPDC_STATIC_BUILD
DEFS   += -DPDC_WIDE
EXTRA_OBJ += wcwidth.o
endif


ifdef ENABLE_NLS
LIBS_EXTRA += -lintl -liconv
endif

UCS=1

ifdef UNINORM
UCS=1
endif

ifdef UCS
EXTRA_OBJ += matchw.o
endif

bindir    = ${exec_prefix}/bin
PROGRAM = wcdwin32psh.exe
VERSIONSUFFIX = -win32psh
ZIPOBJ_EXTRA =
ifdef ENABLE_NLS
# Using MinGW gettext,iconv
ZIPOBJ_EXTRA += bin/libintl-8.dll bin/libiconv-2.dll
# libgcc_s_dw2-1 and libwinpthread-1 are needed when built with MSYS2 
ZIPOBJ_EXTRA += bin/libgcc_s_dw2-1.dll bin/libwinpthread-1.dll
endif

ifdef UNINORM
ifndef ENABLE_NLS
ZIPOBJ_EXTRA += bin/libgcc_s_dw2-1.dll bin/libwinpthread-1.dll
# libunistring needs libiconv
ZIPOBJ_EXTRA += bin/libiconv-2.dll
endif
ZIPOBJ_EXTRA += bin/libunistring-2.dll
endif

ifeq ($(findstring ncurses,$(CURSES)),ncurses)
ifneq ($(findstring libwinpthread,$(ZIPOBJ_EXTRA)),libwinpthread)
ZIPOBJ_EXTRA += bin/libwinpthread-1.dll
endif
endif


all :
	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} EXTRA_OBJ="${EXTRA_OBJ}" ENABLE_NLS=${ENABLE_NLS}

install :
	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} EXTRA_OBJ="${EXTRA_OBJ}" INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS}

uninstall :
	${MAKE} -C ../src uninstall PROGRAM=${PROGRAM} prefix=${prefix} ENABLE_NLS=${ENABLE_NLS}


dist :
	${MAKE} -C ../src dist-zip ZIPOBJ_EXTRA="${ZIPOBJ_EXTRA}" PROGRAM=${PROGRAM} prefix=${prefix} VERSIONSUFFIX=${VERSIONSUFFIX} ENABLE_NLS=${ENABLE_NLS}

strip:
	${MAKE} -C ../src strip PROGRAM=${PROGRAM}

mostlyclean :
	${MAKE} -C ../src mostlyclean

clean :
	${MAKE} -C ../src clean

=== win64zsh/Makefile ===

PREFIX = c:/usr/local64
prefix = $(PREFIX)
exec_prefix = $(prefix)
MKDIR  = mkdir
LIBS_EXTRA = -lkernel32 -luser32 -lmpr

#CC = x86_64-w64-mingw32-gcc
#STRIP = x86_64-w64-mingw32-strip
CC = gcc
STRIP = strip
CFLAGS = -O2 -Wall -Wextra -Wconversion -Wno-unused-parameter
CURSES = pdcursesw
ENABLE_NLS =
DEFS   = -DWCD_WINZSH

ifdef CURSES
LIB_CURSES = -l${CURSES}
DEFS   += -DWCD_USECURSES -DPDC_STATIC_BUILD
DEFS   += -DPDC_WIDE
EXTRA_OBJ += wcwidth.o
endif


ifdef ENABLE_NLS
LIBS_EXTRA += -lintl -liconv
endif

UCS=

ifdef UNINORM
UCS=1
endif

ifdef UCS
EXTRA_OBJ += matchw.o
endif

bindir    = ${exec_prefix}/bin
PROGRAM = wcdwin64zsh.exe
VERSIONSUFFIX = -win64zsh
ZIPOBJ_EXTRA =
ifdef ENABLE_NLS
# Using MinGW gettext,iconv
ZIPOBJ_EXTRA += bin/libintl-8.dll bin/libiconv-2.dll
endif

ifdef UNINORM
ifndef ENABLE_NLS
# libunistring needs libiconv
ZIPOBJ_EXTRA += bin/libiconv-2.dll
endif
ZIPOBJ_EXTRA += bin/libunistring-2.dll
endif

ifeq ($(findstring ncurses,$(CURSES)),ncurses)
ifneq ($(findstring libwinpthread,$(ZIPOBJ_EXTRA)),libwinpthread)
ZIPOBJ_EXTRA += bin/libwinpthread-1.dll
endif
endif


all :
	${MAKE} -C ../src all PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} EXTRA_OBJ="${EXTRA_OBJ}" ENABLE_NLS=${ENABLE_NLS} CC=${CC} UCS=${UCS}

install :
	${MAKE} -C ../src install PROGRAM=${PROGRAM} CFLAGS="${CFLAGS}" CURSES=${CURSES} LIB_CURSES=${LIB_CURSES} DEFS="${DEFS}" LIBS_EXTRA="${LIBS_EXTRA}" prefix=${prefix} MKDIR=${MKDIR} EXTRA_OBJ="${EXTRA_OBJ}" INSTALL_OBJS_DOC_INSTALL="../doc/INST_DOS.txt ../doc/INSTALL.txt" ENABLE_NLS=${ENABLE_NLS} CC=${CC} UCS=${UCS}

uninstall :
	${MAKE} -C ../src uninstall PROGRAM=${PROGRAM} prefix=${prefix} ENABLE_NLS=${ENABLE_NLS} UCS=${UCS}


dist :
	${MAKE} -C ../src dist-zip ZIPOBJ_EXTRA="${ZIPOBJ_EXTRA}" PROGRAM=${PROGRAM} prefix=${prefix} VERSIONSUFFIX=${VERSIONSUFFIX} ENABLE_NLS=${ENABLE_NLS} UCS=${UCS}

strip:
	${MAKE} -C ../src strip PROGRAM=${PROGRAM} STRIP=$(STRIP)

mostlyclean :
	${MAKE} -C ../src mostlyclean

clean :
	${MAKE} -C ../src clean

=== src/man/man1/Makefile ===
# pod2man.mk -- Makefile portion to convert *.pod files to manual pages
#
#   Copyright information
#
#       Copyright (C) 2008-2009 Jari Aalto
#       Copyright (C) 2010-2017 Erwin Waterlander
#
#   License
#
#       This program is free software; you can redistribute it and/or
#       modify it under the terms of the GNU General Public License as
#       published by the Free Software Foundation; either version 2 of the
#       License, or (at your option) any later version
#
#       This program is distributed in the hope that it will be useful, but
#       WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#       General Public License for more details at
#       Visit <http://www.gnu.org/copyleft/gpl.html>.
#
#   Description
#
#       Convert *.pod files to manual pages.

ifneq (,)
    This makefile requires GNU Make.
endif

include ../../version.mk

.PRECIOUS: %.pod

# This variable *must* be set when calling
PACKAGE         ?= wcd

# Optional variables to set
MANSECT         ?= 1
PODCENTER       ?= $(VERSION_DATE)

# Directories
MANSRC          =
MANDEST         = $(MANSRC)

MANPOD          = $(MANSRC)$(PACKAGE).pod
MANPAGE         = $(MANDEST)$(PACKAGE).$(MANSECT)

POD2MAN         = pod2man
POD2MAN_FLAGS   =

POFILES = $(wildcard ../../po-man/*.po)
PODFILES = $(patsubst ../../po-man/%.po,../%/man1/wcd.pod,$(POFILES))
MAN_OBJECTS = wcd.1 $(patsubst %.pod,%.1,$(PODFILES))

MKDIR = mkdir

all: $(MAN_OBJECTS) ../../po-man/wcd-man.pot


../../po-man/wcd-man.pot : wcd.pod
	po4a-updatepo -f pod -m $< -p $@ --msgmerge-opt --no-wrap

%.po : wcd.pod
	po4a-updatepo -f pod -m $< -p $@ --msgmerge-opt "--backup=numbered --no-wrap"
	# change timestamp in case .po file was not updated.
	touch $@

# Create pod files from po.
# Fix problem that =encoding is before =pod command.
../%/man1/wcd.pod : ../../po-man/%.po
	$(MKDIR) -p $(dir $@)
	po4a-translate -f pod -m wcd.pod -p $< > $@ -k 30
	perl -ni.bak -e 'print unless /=encoding UTF-8/' $@
	perl -pli.bak -e 's/=pod/=pod\n\n=encoding UTF-8/' $@

# An empty recipe for wcd.pod to break circular dependency.
wcd.pod : ;

%.1 : %.pod
	# make target - create manual page from a *.pod page
	podchecker $<
	$(POD2MAN) $(POD2MAN_FLAGS) \
		--utf8 \
		--center="$(PODCENTER)" \
		--name="$(PACKAGE)" \
		--section="$(MANSECT)" \
		$< \
	| perl -p -e 's/[Pp]erl v[0-9.]+/$(PACKAGE)/;' \
	  > $@ && \
	rm -f pod*.tmp



clean:
	rm -f $(MAN_OBJECTS)
	rm -f wcd-man.pot
	rm -f $(PODFILES)

# End of of Makefile part

=== debian/changelog ===
wcd (6.0.5-1build1) noble; urgency=medium

  * Rebuild against latest libunistring

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 26 Oct 2023 20:54:04 -0400

wcd (6.0.5-1) unstable; urgency=medium

  * QA upload.
  * New upstream release 6.0.5.
  * debian/control:
    + Bump Standards-Version to 4.6.2.
    + Use up-to-date project homepage.
  * debian/watch: Update monitoring scripts.
  * debian/upstream/signing-key.asc: Add signing public key.

 -- Boyuan Yang <byang@debian.org>  Sun, 24 Sep 2023 14:56:23 -0400

wcd (6.0.3-4) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Update standards version to 4.5.1, no changes needed.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 08 Dec 2022 01:06:38 +0000

wcd (6.0.3-3) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Repository.
  * Update standards version to 4.5.0, no changes needed.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 13 Oct 2022 14:58:18 +0100

=== debian/control ===
Source: wcd
Section: utils
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13), libncurses-dev, libunistring-dev, ghostscript
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/wcd
Vcs-Git: https://salsa.debian.org/debian/wcd.git
Homepage: https://waterlan.home.xs4all.nl/wcd.html

Package: wcd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: saves time typing when you want to change directories
 Wcd (Wherever Change Directory) is a program to quickly change directories.
 It saves time typing at the keyboard. One needs to type only a part of a
 directory name and wcd will jump to it. By default, wcd searches for a
 directory with a name that begins with what has been typed, but the use of
 wildcards is also fully supported.

=== debian/watch ===
version=4
# http://sf.net/wcd/wcd-([.\d]*)\.tar\.gz
opts="pgpmode=auto,uversionmangle=s/-beta/~beta/" \
 https://waterlan.home.xs4all.nl/wcd.html \
 https://waterlan.home.xs4all.nl/wcd/wcd-@ANY_VERSION@\.tar\.gz

## wcd 6.0.6

=== debian/changelog ===
wcd (6.0.6-1) unstable; urgency=medium

  * QA upload.
  * New upstream release 6.0.6.

 -- Boyuan Yang <byang@debian.org>  Tue, 09 Dec 2025 19:45:45 -0500

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends: debhelper-compat (= 13), libncurses-dev, libunistring-dev, ghostscript
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/wcd
 Vcs-Git: https://salsa.debian.org/debian/wcd.git
